//
// Generated stub from file:/Users/daleyl/Projects/gldapo/target/checkout/src/main/groovy/gldapo/GldapoDirectory.groovy
//

package gldapo;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import groovy.lang.*;
import groovy.util.*;
import gldapo.schema.GldapoContextMapper;
import gldapo.schema.GldapoSchemaRegistration;
import gldapo.exception.GldapoException;
import gldapo.exception.GldapoInvalidConfigException;
import gldapo.search.SearchControlProvider;
import gldapo.search.SearchControls;
import gldapo.search.SearchProvider;
import org.springframework.ldap.core.LdapTemplate;
import org.springframework.ldap.core.support.LdapContextSource;
import org.springframework.ldap.core.ContextMapperCallbackHandler;
import org.springframework.ldap.control.PagedResultsRequestControl;
import org.springframework.ldap.LimitExceededException;
import org.springframework.ldap.core.ContextMapper;
import org.springframework.ldap.NamingException;
import javax.naming.directory.ModificationItem;
import javax.naming.directory.Attributes;
import org.springframework.ldap.core.DistinguishedName;

public class GldapoDirectory
    extends java.lang.Object
    implements SearchProvider
{
    /**
     * The key that the config for the directories search controls should be under ({@value})
     *
     * @see #GldapoDirectory(String,Map)
     */
    static final private java.lang.Object CONFIG_SEARCH_CONTROLS_KEY = null;
    static final public java.lang.Object getCONFIG_SEARCH_CONTROLS_KEY() {
        throw new InternalError("Stubbed method");
    }

    /**
     * The attributes in the config that are for the underlying context source of the underlying template.
     * <p>
     * The properties and their meanings are ...
     * <ul>
     * <li>url - A string indicating the location of the directory (e.g. {@code "ldap://example.com"})
     * <li>urls - A list of url strings
     * <li>base - The base dn for operations for this directory (e.g. {@code "dc=example,dc=com"})
     * <li>userDn - The distinguished name of the user to bind to the directory as
     * <li>password - The password of the user to bind as
     * </ul>
     */
    static final private java.lang.Object CONTEXT_SOURCE_PROPS = null;
    static final public java.lang.Object getCONTEXT_SOURCE_PROPS() {
        throw new InternalError("Stubbed method");
    }

    /**
     */
    private SearchControlProvider searchControls = null;
    public SearchControlProvider getSearchControls() {
        throw new InternalError("Stubbed method");
    }
    public void setSearchControls(SearchControlProvider value) {
        throw new InternalError("Stubbed method");
    }

    /**
     */
    private java.lang.String name = null;
    public java.lang.String getName() {
        throw new InternalError("Stubbed method");
    }
    public void setName(java.lang.String value) {
        throw new InternalError("Stubbed method");
    }

    /**
     */
    private java.lang.Object template = null;
    public java.lang.Object getTemplate() {
        throw new InternalError("Stubbed method");
    }
    public void setTemplate(java.lang.Object value) {
        throw new InternalError("Stubbed method");
    }

    private GldapoDirectory(java.lang.Void void1, java.lang.Void void2, java.lang.Void void3) {
        throw new InternalError("Stubbed method");
    }

    /**
     * Creates a new instance via a config map.
     * <p>
     * The config map contains the attributes for the underlying {@link LdapContextSource}
     * (see {@link #CONTEXT_SOURCE_PROPS}). The only mandatory attribute is {@code url}
     * (or {@code urls}). The rest are optional.
     * <p>
     * It can also contain a map under the key denoted by {@link #CONFIG_SEARCH_CONTROLS_KEY}
     * that is used to construct an instance of {@link SearchControls} using the
     * {@link SearchControls#SearchControls(Map)} constructor. If it is omitted, a search controls
     * object with default values is used.
     * <p>
     */
    public GldapoDirectory(java.lang.String name, Map config) {
        this((java.lang.Void)null, (java.lang.Void)null, (java.lang.Void)null);
        throw new InternalError("Stubbed method");
    }

    /**
     * Returns the base DN for operations for this directory
     */
    public DistinguishedName getBase() {
        throw new InternalError("Stubbed method");
    }

    /**
     * Performs a search operation on the directory.
     * <p>
     * If the search control provider contains a {@code pageSize} that is greater than 1
     * {@link #pagedSearch(DistinguishedName,String,SearchControls,ContextMapperCallbackHandler,Integer) pagedSearch()} is used,
     * otherwise {@link #nonPagedSearch(DistinguishedName,String,SearchControls,ContextMapperCallbackHandler) nonPagedSearch()} is used.
     * <p>
     * An instance of {@link SearchControls} is made out of the gldapo search controls ({@code controls}) to be used by
     * the {@link LdapTemplate} instance which does the actual searching.
     *
     * @param schemaRegistration Provides the metadata about the target class in order to make objects (must be instance of GldapoSchemaRegistration)
     * @param base The base of the search operation, relative to the base of the directory
     * @param filter The LDAP filter string to use to restrict the search
     * @param controls Provides several settings that augment the search
     * @return A list of objects of the class that the schemaRegistration is for
     * @throws NamingException If any LDAP related error occurs
     */
    public List search(java.lang.Object schemaRegistration, DistinguishedName base, java.lang.String filter, SearchControlProvider controls) throws NamingException {
        throw new InternalError("Stubbed method");
    }

    /**
     * Performs a search operation on the directory not using paging.
     *
     * @param base The base of the search operation, relative to the base of the directory
     * @param filter The LDAP filter string to use to restrict the search
     * @param jndiControls Provides several settings that augment the search
     * @param handler responsible for processing the raw search results
     * @return A list of objects of the class that the schemaRegistration is for
     * @throws NamingException If any LDAP related error occurs
     */
    private List nonPagedSearch(DistinguishedName base, java.lang.String filter, javax.naming.directory.SearchControls jndiControls, ContextMapperCallbackHandler handler) throws NamingException {
        throw new InternalError("Stubbed method");
    }

    /**
     * Performs a search operation on the directory not using paging.
     *
     * @param base The base of the search operation, relative to the base of the directory
     * @param filter The LDAP filter string to use to restrict the search
     * @param jndiControls Provides several settings that augment the search
     * @param handler responsible for processing the raw search results
     * @param pageSize The number of entries to be returned in one page from the LDAP directory
     * @return A list of objects of the class that the schemaRegistration is for
     * @throws NamingException If any LDAP related error occurs
     */
    private List pagedSearch(DistinguishedName base, java.lang.String filter, javax.naming.directory.SearchControls jndiControls, ContextMapperCallbackHandler handler, Integer pageSize) throws NamingException {
        throw new InternalError("Stubbed method");
    }

    /**
     */
    public void createEntry(DistinguishedName dn, Attributes attributes) {
        throw new InternalError("Stubbed method");
    }

    /**
     */
    public void updateEntry(DistinguishedName dn, List modificationItems) {
        throw new InternalError("Stubbed method");
    }

    /**
     */
    public void moveEntry(DistinguishedName olddn, DistinguishedName newdn) {
        throw new InternalError("Stubbed method");
    }

    /**
     */
    public void replaceEntry(DistinguishedName dn, Attributes attributes) {
        throw new InternalError("Stubbed method");
    }

    /**
     */
    public void deleteEntry(DistinguishedName dn) {
        throw new InternalError("Stubbed method");
    }

    /**
     */
    public void deleteEntryRecursively(DistinguishedName dn) {
        throw new InternalError("Stubbed method");
    }

    public java.lang.Object getSubContextSource(DistinguishedName brdn) {
        throw new InternalError("Stubbed method");
    }

    public groovy.lang.MetaClass getMetaClass() {
        throw new InternalError("Stubbed method");
    }

    public void setMetaClass(groovy.lang.MetaClass metaClass) {
        throw new InternalError("Stubbed method");
    }

    public java.lang.Object invokeMethod(java.lang.String name, java.lang.Object args) {
        throw new InternalError("Stubbed method");
    }

    public java.lang.Object getProperty(java.lang.String name) {
        throw new InternalError("Stubbed method");
    }

    public void setProperty(java.lang.String name, java.lang.Object value) {
        throw new InternalError("Stubbed method");
    }
}
